// besseres Beispiel fuer den Gebrauch von typeid: 
// es soll zur Laufzeit entschieden werden, ob zwei geoFormen durch einfache
// Verschiebung zur Deckung gebracht werden koennen - dazu ist erst einmal
// festzustellen, ob beide Formen vom gleichen Typ sind!
// danach wird dann der dynamische Cast auch noch gebraucht
#include <iostream>
#include <cstdlib>
#include <typeinfo>

using namespace std;

class geoForm {		// geom. Form "an sich" gibt es nicht = abstrakte Klasse
	float inhalt;	// Flaecheninhalt der Form (falls berechenbar)
	virtual bool searchTrafo(geoForm *x) = 0;	// NEU!! suche Trafo!
public:
	geoForm(float f=0) : inhalt(f) { }
	float flaecheninhalt() { return inhalt; }
	virtual void zeigeform() = 0;	// ex. keine Implementierung!
	virtual void dreheform(int grad) = 0;	// DREHEFORM WIEDER VIRTUAL
	virtual ~geoForm()  { }
	// NEU
	virtual bool isEqual(geoForm *x) {	// *this trafo-aequivalent zu x
		if (typeid(*this)==typeid(*x))	// nur dann ist Suche sinnvoll!
			return searchTrafo(x); // suche nach mgl. Transformation
		else				// ungleiche Typen! Geht nicht!
			return false;
	}
};

class kreis : public geoForm {			// ein Kreis ist eine geom. Form
	int mittelx; int mittely;		// Mittelpunkt 
	float radius;				// Radius
	bool searchTrafo(geoForm *x) {		// NEU !!!
		kreis *k = dynamic_cast<kreis*>(x);
		return radius==k->radius;	// es existiert eine Trafo ...
	}
public:
	kreis(int mx, int my, float radius) :
		geoForm(radius*radius*3.1415), mittelx(mx), mittely(my)  { }
	void zeigeform() { cout <<"O"<< endl;} // to be programed later ...
	void dreheform(int grad) { }		// to be programed later ...
	~kreis() { }				// nothing to do ...
};

class quadrat : public geoForm {		// ein Quadrat ist eine Form
	int linksobenx, linksobeny;		// linke obere Ecke
	float seitenlaenge;
	bool searchTrafo(geoForm *x) {		// NEU !!!
		quadrat *q = dynamic_cast<quadrat*>(x);
		return seitenlaenge==q->seitenlaenge;	// Trafo existiert!
	}
public:
	quadrat(int lx, int ly, float len) :
		geoForm(len*len), linksobenx(lx), linksobeny(ly) { }
	void zeigeform() { cout <<"[]"<< endl;} // to be programed later ...
	void dreheform(int grad) { }		// to be programed later ...
	~quadrat() { }				// nothing to do ...
};

int main()
{
	geoForm *f = new quadrat(2,3, 10);	// Quadrat der Seitenlaenge 10
	cout << "ich bin so gross: "<<f->flaecheninhalt();
	cout <<" und sehe so aus: ";
	f->zeigeform();

	geoForm *k = new kreis(3,3, 1);		// Kreis mit Radius 1 um (3, 3)
	cout << "ich bin so gross: "<<k->flaecheninhalt();
	cout <<" und sehe so aus: ";
	k->zeigeform();

	if (!k->isEqual(f))
		cout <<"Es gibt keine Trafo von f nach k"<<endl;
	else
		cout <<"Es gibt EINE Trafo von f nach k"<<endl;

	geoForm *k2 = new kreis(2,2, 1);	// Kreis mit Radius 1 um (2, 2)
	if (!k2->isEqual(k))
		cout <<"Es gibt keine Trafo von k2 nach k"<<endl;
	else
		cout <<"Es gibt EINE Trafo von k2 nach k"<<endl;

	return 0;
}
