// maps (assoziative Arrays) koennen Wertepaare abspeichern
// Indexzugriff: ueber den ersten Datentyp des Wertepaars
#include <iostream>
#include <map>
using namespace std;

struct person {
	char *name;
	int alter;
} init[] = {				// Initialisierungsvektor zum Testen
	{	"hans", 19 },
	{	"frans", 22 },
	{	"klaus", 42 },
	{	"josi", 122 },
	{	"peter", 13 },
	{	"karl", 12 }
};

int main()
{	// bitte NICHT map<char*, int> !!!!
	map<string, int> personen;	// Anlegen der leeren Map

	for (unsigned int i=0; i<sizeof(init)/sizeof(*init); i++) 
		// Zuweisung: personen[string] = int -- string ist der Index!
		// also z.B. personen["hans"] = 12
		personen[(string)init[i].name] = init[i].alter;

	while (!cin.eof()) {
		string input;
		cout <<"Fuer wen willsch das Alter wisse? ";
		if (getline(cin, input)) {
			cout <<input <<" ist "<<personen[input]<<" Jahre alt!";
			cout <<endl;
		}
	}
	// Achtung: ein Zugriff auf ein vorher nicht definiertes Element legt 
	// ein neues Paar an!! (cout <<<personen["heinz"]; legt ("heinz", 0) an!
	cout <<"Hier noch mal die komplette Tabelle:"<<endl;

	map<string, int>::iterator i;		// Datentyp des "Iterators"
	for (i=personen.begin(); i!=personen.end(); i++)
		cout <<i->first<<" - Alter: "<<i->second<<endl;

	// Abfrage ohne Neuanlegen
	i = personen.find("josch");		// Methode find() verwenden
	if (i!=personen.end())			// josch gefunden!!
		cout <<"josch gips in Personen. Alter: "<<i->second<<endl;
	else
		cout <<"josch gips NICHT in Personen. "<<endl;

	for (i=personen.begin(); i!=personen.end(); i++)
		cout <<i->first<<" - Alter: "<<i->second<<endl;
	return 0;
}
