// kleines Testprogramm, dass den Stack mit etwas komplizierteren 
// Datenstrukturen fttert
// "Sachbearbeiter", der die Akten "Last in First out" abarbeitet
#include "stack.h"
#include <iostream>

using namespace std;			// required containing cout, endl ...
using namespace stack;			// required for stack operations

typedef struct akte {			// eine Akte ...
	char *bezeichnung;
	int nr;				// laufende Nummer
	char *eingangsdatum;
} Akte;

// process one file: getting a pointer to Akte
void process(Akte *p)
{
	cout << "Bearbeite: Nr. "<<p->nr<<" '";
	cout << p->bezeichnung << "', eingegangen am "<<p->eingangsdatum;
	cout << endl;
}

// gib maximal 2 Beamten Arbeit!
// nett: stapel ist eine Referenz auf einen Pointer ...
void loadClerkWithWork(Stack<Akte*>* &stapel)
{	static int num_of_calls = 0;
	static Akte stapel1[] = {		// create 3 cases
		{ "Antrag auf Personalausweis", 1, "13.12.2001"},
		{ "Einbuergerungsverfahren", 2, "21.4.2002"},
		{ "Exmatrikulationsgesuch", 3, "28.10.2002"}
	};
	static Akte stapel2[] = {		// create 4 cases
		{ "Einbuergerungsverfahren", 1, "21.4.2002"},
		{ "Einbuergerungsvergahren", 2, "13.12.2001"},
		{ "Visumsantrag", 3, "28.10.2002"},
		{ "Verlaengerungsantrag", 4, "28.10.2002"}
	};
	int size;				// Anzahl Akten im Eingang
	Akte *akten;				// Zeiger auf Aktenberg

	if (++num_of_calls==1) {		// 1.Aufruf
		akten = stapel1;
		size = sizeof(stapel1)/sizeof(*stapel1);	
	} else {				// 2.Aufruf
		akten = stapel2;
		size = sizeof(stapel2)/sizeof(*stapel2);	
	}

	newStack(stapel);			// initialisieren
	for (int i=0; i<size; i++)		// Akten auf Stapel ...
		push(stapel, akten+i);
}

int main()
{	Stack<Akte*> *clerk1, *clerk2;		// 2 (un-)deutsche Beamte
	
	loadClerkWithWork(clerk1);		// gib dem 1.Beamten Arbeit!
	loadClerkWithWork(clerk2);		// gib dem 2.Beamten Arbeit!

	cout <<"Clerk 1:"<<endl;
	while (!isEmpty(clerk1))		// lass ihn arbeiten ...
		process(pop(clerk1));
	
	cout <<"Clerk 2:"<<endl;
	while (!isEmpty(clerk2))		// lass auch ihn arbeiten ...
		process(pop(clerk2));
	
	deleteStack(clerk1);		// not really needed, but ...
	deleteStack(clerk2);		// you better call it. 
					// Implementation of stack may change
					// without notice ...
	return 0;
}
